program checkthreadinfo;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}
  cthreads,
  baseunix,
  unixtype,
  {$ENDIF}
  Classes, dynlibs;

{$I pthread_my.inc}
{$linklib pthread}

type
  TMyThread = class(TThread)
    procedure Execute; override;
  end;

procedure GetPThreadsStackInfo(var stackBase: Pointer;
                               var stackSize: LongWord;
                               var stackPtr: Pointer);
var
  thread: pthread_t;
  sattr: pthread_attr_t;
  p:pointer;
begin
  thread := pthread_self();

  asm
    movl %esp, p
  end;

  stackPtr := p;

  pthread_getattr_np(thread, @sattr);
  pthread_attr_getstack(@sattr, stackBase, stackSize);
end;

procedure ShowThreadInfo;
var
  PthstackBase: Pointer = nil;
  PthstackSize: LongWord = 0;
  PthstackPtr: Pointer = nil;
begin
  GetPThreadsStackInfo(PthstackBase, PthstackSize, PthstackPtr);

  writeln('CurrentThreadId      : ', GetCurrentThreadId);
  writeln('Thread ID            : ', ThreadId);
  writeln('Stack ptr            : ', hexStr(Sptr));
  writeln('Stack top            : ', hexStr(StackTop));
  writeln('Stack bottom         : ', hexStr(StackBottom));
  writeln('Stack length         : ', StackLength);
  writeln('Pthr ThreadId        : ', pthread_self());
  writeln('Pthr Stack ptr       : ', hexStr(PthstackPtr));
  writeln('Pthr Stack top       : ', hexStr(PthstackBase + PthstackSize));
  writeln('Pthr Stack bot       : ', hexStr(PthstackBase));
  writeln('Pthr Stack Len       : ', PthstackSize);
end;

type
  TShowInfo = procedure;

var
  h: THandle;
  si: TShowInfo;
  t: TMyThread;

procedure TMyThread.Execute;
begin
  Writeln('< worker thread, main program >');
  ShowThreadInfo;
  Writeln('< worker thread, library >');
  si();
end;

begin
  Writeln('MainThreadId      : ', MainThreadID);

  Writeln('< main thread, main program >');
  ShowThreadInfo();

  h := LoadLibrary('./libthreadinfolibPTH.so');
  if h <> 0 then
  begin
    si := TShowInfo(GetProcAddress(h, 'ShowThreadInfo'));
    if Assigned(si) then
    begin
      Writeln('< main thread, library >');
      si();
    end;
  end
  else
  begin
    writeln('Cannot load library');
    Exit;
  end;

  t := TMyThread.Create(False, DefaultStackSize);
  t.Free;

  if h <> 0 then
    UnloadLibrary(h);
end.

