library ThreadInfoLibPTH;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}
  cthreads,
  baseunix,
  unixtype
  {$ENDIF}
  ;

{$I pthread_my.inc}
{$linklib pthread}

procedure GetPThreadsStackInfo(var stackBase: Pointer;
                               var stackSize: LongWord;
                               var stackPtr: Pointer);
var
  thread: pthread_t;
  sattr: pthread_attr_t;
  p:pointer;
begin
  thread := pthread_self();

  asm
    movl %esp, p
  end;

  stackPtr := p;

  pthread_getattr_np(thread, @sattr);
  pthread_attr_getstack(@sattr, stackBase, stackSize);
end;

procedure ShowThreadInfo;
var
  PthstackBase: Pointer = nil;
  PthstackSize: LongWord = 0;
  PthstackPtr: Pointer = nil;
begin
  GetPThreadsStackInfo(PthstackBase, PthstackSize, PthstackPtr);

  writeln('Libr. CurrentThreadId: ', GetCurrentThreadId);
  writeln('Libr. ThreadId       : ', ThreadId);
  writeln('Libr. Stack ptr      : ', hexStr(Sptr));
  writeln('Libr. Stack top      : ', hexStr(StackTop));
  writeln('Libr. Stack bottom   : ', hexStr(StackBottom));
  writeln('Libr. Stack length   : ', StackLength);
  writeln('Libr. Pthr ThreadId  : ', pthread_self());
  writeln('Libr. Pthr Stack ptr : ', hexStr(PthstackPtr));
  writeln('Libr. Pthr Stack top : ', hexStr(Pthstackbase + Pthstacksize));
  writeln('Libr. Pthr Stack bot : ', hexStr(PthstackBase));
  writeln('Libr. Pthr Stack Len : ', PthstackSize);
end;

exports
  ShowThreadInfo;

begin
end.

